/*
The function dynamical_averages calculates the average value of the kinetic
and of the total energy per particle and of the percentage error of the
integrator

In order not to write into the disk all the time, we construct a vector dat[][],
and save temporarely our data there. Once in a while (controlled by the parameter size_dat), we flush it into the
disk and set it into zero again.

INPUT: unsigned long t
OUTPUT: void
CHANGES:
USES: int size_dat=1000, cont=0, contint=0, prima=1;
*/
#include<stdio.h>

extern int N, M, vez;
extern unsigned long T;
extern double U, K, KM, V, VM, Vi, mx_M, my_M;
extern double **dat, *EK_med, *VM_med, *Vi_med, *m_med;
extern char file_name2[];

extern int size_dat, cont, contint, prima;

void  dynamical_averages(unsigned long t){

  int i;
  FILE *Efile;

  cont++;
  EK_med[t]     = ((vez-1)*EK_med[t]+KM)/(double)vez;
  VM_med[t]     = ((vez-1)*VM_med[t]+VM)/(double)vez;
  Vi_med[t]     = ((vez-1)*Vi_med[t]+Vi)/(double)vez;
  m_med[t]      = ((vez-1)*m_med[t]+(mx_M*mx_M+my_M*my_M))/(double)vez;

  dat[cont][0] = 2.0*EK_med[t]/(double)M;
  dat[cont][1] = (EK_med[t]+VM_med[t])/(double)M;
  dat[cont][2] = m_med[t];
  dat[cont][3] = Vi_med[t];
  dat[cont][4] = fabs( U-( (K+V)/(double)N ) )/(double)U*100;

  /*If we fill dat (or time is over), we write it down in a file*/
  if(cont==size_dat || t==T){
    if(prima==1){
      Efile=fopen(file_name2,"w");
      prima=0;
    }
    else Efile=fopen(file_name2,"a");

    for(i=1; i<=size_dat; i++)
      if(dat[i][0]!=0.0 || dat[i][1]!=0.0 || dat[i][2]!=0.0 || dat[i][3]!=0.0)
	fprintf(Efile,"%d %lf %lf %lf %.12lf %.12lf\n", i+contint*size_dat, dat[i][0],
		dat[i][1], dat[i][2], dat[i][3], dat[i][4]);

    fclose(Efile);

    if(cont==size_dat)
      for(i=1; i<=size_dat; i++){
        dat[i][0]=0.0;
        dat[i][1]=0.0;
        dat[i][2]=0.0;
        dat[i][3]=0.0;
        dat[i][4]=0.0;
      }

    cont=0;
    contint++;

  }

  return;

}
