/*
 * $Id: config.h,v 1.3 2005/05/08 16:37:58 amaia Exp $
 */
#ifndef __CONFIG_H
#define __CONFIG_H

#include "pup_stl.h"

class config {
	u64 N;
	u64 M;
	ldouble tau;
	ldouble U;
	u64 VEZ;
	ldouble S2;
	ldouble mtarget;
	u64 Ttrans;
	u64 T;
	ldouble Emax;
	ldouble sigma_gauss_q;
	ldouble sigma_gauss_p;
	
	std::string cfg_file;
	std::string out_dir;
	std::string inp_dir;

	//std::vector<std::string> input;
	
	int debug_level;
	
	int _argc;
	char** _argv;

	public:
	config(): _argc(0), _argv(0) {}
	config(int argc, char** argv): _argc(argc), _argv(argv) {}
	void init(int ac, char** av) {  _argc = ac; _argv = av; }
	int read();

	void pup(PUP::er &p);

	u64 get_N() { return N; }
	u64 get_M() { return M; }
	u64 get_VEZ() { return VEZ; }
	u64 get_Ttrans() { return Ttrans; }
	u64 get_T() { return T; }
	ldouble get_tau() { return tau; }
	ldouble get_U() { return U; }
	ldouble get_S2() { return S2; }
	ldouble get_mtarget() { return mtarget; }
	ldouble get_Emax() { return Emax; }
	ldouble get_sigma_gauss_q() { return sigma_gauss_q; }
	ldouble get_sigma_gauss_p() { return sigma_gauss_p; }
	int get_debug_level() { return debug_level; }
	std::string get_out_dir() { return out_dir; }
	std::string get_inp_dir() { return inp_dir; }
};

#endif
